Successfully converts to binary on odd numbers, fails on even numbers - java
I have an issue with my Java program. I made a program that takes an integer and converts it to it's value in binary. When the number is odd, there aren't any problems. 15 converts to 1111, 17 converts to 10001 and so on. The issue comes when the number is even. If I put in 16, 18, 20, etc, it just returns 0. Every time. Also, important to note that I get my number by using a recursive method that stops once it arrives at it's number.
Here's my code. Appreciate any help I can get, even if it doesn't solve the problem.
public class binaryConverter {
static int nr = 16;
static int max = 0;
static int[] bin;
static int[] array;
static int finalBin;
public static void main(String[] args) {
maxFinder();
binMaker();
toBinary(array, 0,true);
}
//finds out how many binary numbers are used in order to decide what length to make the array,
//15 = 1111, 10000 = 16 15<16
private static void maxFinder(){
for(int i = 0, n = 1; i<nr; i++){
if(n>nr){
max = i;
break;
}
n*=2; //n doubles for every i loop, starts with one
}
}
//makes a library of standard to binary (0 = 1, 1 = 2; 2 = 4; 3 = 8...)
private static void binMaker(){
int[] temp = new int[max];
for(int i = 0; i<temp.length; i++){
if(i == 0) temp[i] = 1;
else temp[i]=2*temp[i-1];
}
bin = temp;
array = new int[bin.length];
}
//adds the array together in order to access what number the array currently resembles in binary
private static int sum(int[] ar, int length){
int sum = 0;
for(int i = 0; i<=length; i++) if(ar[i]==1) sum += bin[i];
return sum;
}
//loops until the array becomes the number in binary
private static void toBinary(int[] ar, int i, boolean one){ //i = the current number it's on, eg. 10i01, i is the third slot
if(i==array.length) return; //break if
ar[i] = (one) ? 1:0;
if(sum(ar, i)==nr){ //if the temporary array is the number but in binary ...
array = ar; //turns the static array into the temporary array
String temp = "";
for(int z = 0; z<array.length; z++) temp += array[z];
finalBin = Integer.parseInt(temp); //makes finalBin represent the original number but in binary
return;
}
else{ //else go to the next slot
toBinary(ar, i+1, true);
toBinary(ar, i+1, false);
}
}
}
Edit: I have now added the following line to my main:
if(finalBin != nr) toBinary(array,0,false);
System.out.println(finalBin);
This is to make sure that it can start with 0 aswell. However, I still get the incorrect answer, as it gives me pretty seemingly random returns on even numbers.
You starting you recursion always with a one at the first place of the binary:
toBinary(array, 0, true);
This way you never can get an even number. An even number always has a zero at the "first" bit (representing "2 to the power of 0").
You could start the recursion like so:
toBinary(array, 0, true);
if (/* not found a solution */)
toBinary(array, 0, false);
You can use this code as converter and replace String type to some List:
public static String decToBin(int value) {
String result = "";
while (value > 1) {
result += value % 2;
value /= 2;
}
result += value;
result = new StringBuilder(result)
.reverse()
.toString();
return result;
}
This is how you could get it to work:
public class binaryConverter {
static int nr = 16;
static int max = 0;
static int[] bin;
static int[] array;
static int finalBin;
static boolean foundSolution = false;
public static void main(String[] args) {
maxFinder();
binMaker();
toBinary(array, 0, true);
if (!foundSolution)
toBinary(array, 0, false);
for (int i = array.length - 1; i >= 0; i--)
System.out.print(array[i]);
System.out.println();
}
//finds out how many binary numbers are used in order to decide what length to make the array,
//15 = 1111, 10000 = 16 15<16
private static void maxFinder(){
for(int i = 0, n = 1; i<nr; i++){
if(n>nr){
max = i;
break;
}
n*=2; //n doubles for every i loop, starts with one
}
}
//makes a library of standard to binary (0 = 1, 1 = 2; 2 = 4; 3 = 8...)
private static void binMaker(){
int[] temp = new int[max];
for(int i = 0; i<temp.length; i++){
if(i == 0) temp[i] = 1;
else temp[i]=2*temp[i-1];
}
bin = temp;
array = new int[bin.length];
}
//adds the array together in order to access what number the array currently resembles in binary
private static int sum(int[] ar, int length){
int sum = 0;
for(int i = 0; i<=length; i++) if(ar[i]==1) sum += bin[i];
return sum;
}
//loops until the array becomes the number in binary
private static void toBinary(int[] ar, int i, boolean one){ //i = the current number it's on, eg. 10i01, i is the third slot
if(i==array.length || foundSolution) return; //break if
ar[i] = (one) ? 1:0;
if(sum(ar, i)==nr){ //if the temporary array is the number but in binary ...
array = ar; //turns the static array into the temporary array
String temp = "";
for(int z = 0; z<array.length; z++) temp += array[z];
finalBin = Integer.parseInt(temp); //makes finalBin represent the original number but in binary
foundSolution = true;
return;
}
else{ //else go to the next slot
toBinary(ar, i+1, true);
toBinary(ar, i+1, false);
}
}
}
Related
how to construct an array of 100 elements containing the numbers 1 -100 for which shellsort, with the increments 1 4 13 40 (The worst case)?
This is the original question "Shell Sort worst case. Construct an array of 100 elements containing the numbers 1 through 100 for which shellsort, with the increments 1 4 13 40, uses as large a number of compares as you can find." There are 100! permutations for an array of 100 elements, it's terrifying to go through each permutation and find which one has the maximum number of compares. Is there any smarter way to approach this problem? My approach this problem is through violence, but only randomly shuffle the array 100000000 time which is less than 100! and it take me half an hour to get the final output. I pasted my code below. I appreciate any suggestions from you guys! ` package ch_2_1; import edu.princeton.cs.algs4.StdOut; import edu.princeton.cs.algs4.StdRandom; import java.util.Arrays; public class exer_19 { public static void main(String[] args) { // initial permutation int[] array = new int[100]; for ( int i = 1; i < 101; i++) { array[i-1] = i; } // find the worst case and the number of compares worst_input(array); } private static void worst_input(int[] array) { int max_count = 0; int[] copy = new int[100]; int[] worst_case = new int[100]; for ( int i = 0; i < 100000000; i++) { int[] temp = generate(array); for (int j = 0; j < 100; j++){ copy[j] = temp[j];} Shell_sort operation = new Shell_sort(); operation.shell_sort(temp); if (operation.compare() > max_count) { max_count = operation.compare(); worst_case = copy; } System.out.println(i); } for ( int s : worst_case){ System.out.print(s + " ");} System.out.println(); System.out.println(max_count); System.out.println(); } private static int[] generate( int[] array) { StdRandom.shuffle(array); return array; } private static class Shell_sort // it's necessary to create a private class to hold the shell sort method // b/c the method must record the # of compares to sort the array, and this # count need to be returned // to the worst_input method. Therefore, having a class to encapsulate the two methods is very helpful { private int count = 0; private void shell_sort(int[] test) { int N = test.length; int h = 1; while (h < N/3) h = 3*h + 1; // 1, 4, 13, 40, 121... while ( h > 0) { for ( int i = h; i < N; i++) // starting from the largest h-value th element of the array (simplified: ith element) { // if ith element is less than i-h th element, swap the two, continue this process until the condition is not met for ( int j = i; j >= h && less( test[j], test[j-h]); j = j - h) { exchange( test, j, j-h); count++; } } // when reached the end of the array, update h value h = h/3; } } private int compare() { return count; } } private static boolean less( int current, int previous) { return current < previous; } private static void exchange(int[] array, int cur_index, int pre_index) { int temp = array[pre_index]; array[pre_index] = array[cur_index]; array[cur_index] = temp; } } `
How to shift element an int left in an array then adding a number to the end? [duplicate]
I have an array of objects in Java, and I am trying to pull one element to the top and shift the rest down by one. Assume I have an array of size 10, and I am trying to pull the fifth element. The fifth element goes into position 0 and all elements from 0 to 5 will be shifted down by one. This algorithm does not properly shift the elements: Object temp = pool[position]; for (int i = 0; i < position; i++) { array[i+1] = array[i]; } array[0] = temp; How do I do it correctly?
Logically it does not work and you should reverse your loop: for (int i = position-1; i >= 0; i--) { array[i+1] = array[i]; } Alternatively you can use System.arraycopy(array, 0, array, 1, position);
Assuming your array is {10,20,30,40,50,60,70,80,90,100} What your loop does is: Iteration 1: array[1] = array[0]; {10,10,30,40,50,60,70,80,90,100} Iteration 2: array[2] = array[1]; {10,10,10,40,50,60,70,80,90,100} What you should be doing is Object temp = pool[position]; for (int i = (position - 1); i >= 0; i--) { array[i+1] = array[i]; } array[0] = temp;
You can just use Collections.rotate(List<?> list, int distance) Use Arrays.asList(array) to convert to List more info at: https://docs.oracle.com/javase/7/docs/api/java/util/Collections.html#rotate(java.util.List,%20int)
Instead of shifting by one position you can make this function more general using module like this. int[] original = { 1, 2, 3, 4, 5, 6 }; int[] reordered = new int[original.length]; int shift = 1; for(int i=0; i<original.length;i++) reordered[i] = original[(shift+i)%original.length];
Just for completeness: Stream solution since Java 8. final String[] shiftedArray = Arrays.stream(array) .skip(1) .toArray(String[]::new); I think I sticked with the System.arraycopy() in your situtation. But the best long-term solution might be to convert everything to Immutable Collections (Guava, Vavr), as long as those collections are short-lived.
Manipulating arrays in this way is error prone, as you've discovered. A better option may be to use a LinkedList in your situation. With a linked list, and all Java collections, array management is handled internally so you don't have to worry about moving elements around. With a LinkedList you just call remove and then addLast and the you're done.
Try this: Object temp = pool[position]; for (int i = position-1; i >= 0; i--) { array[i+1] = array[i]; } array[0] = temp; Look here to see it working: http://www.ideone.com/5JfAg
Using array Copy Generic solution for k times shift k=1 or k=3 etc public void rotate(int[] nums, int k) { // Step 1 // k > array length then we dont need to shift k times because when we shift // array length times then the array will go back to intial position. // so we can just do only k%array length times. // change k = k% array.length; if (k > nums.length) { k = k % nums.length; } // Step 2; // initialize temporary array with same length of input array. // copy items from input array starting from array length -k as source till // array end and place in new array starting from index 0; int[] tempArray = new int[nums.length]; System.arraycopy(nums, nums.length - k, tempArray, 0, k); // step3: // loop and copy all the remaining elements till array length -k index and copy // in result array starting from position k for (int i = 0; i < nums.length - k; i++) { tempArray[k + i] = nums[i]; } // step 4 copy temp array to input array since our goal is to change input // array. System.arraycopy(tempArray, 0, nums, 0, tempArray.length); } code public void rotate(int[] nums, int k) { if (k > nums.length) { k = k % nums.length; } int[] tempArray = new int[nums.length]; System.arraycopy(nums, nums.length - k, tempArray, 0, k); for (int i = 0; i < nums.length - k; i++) { tempArray[k + i] = nums[i]; } System.arraycopy(tempArray, 0, nums, 0, tempArray.length); }
In the first iteration of your loop, you overwrite the value in array[1]. You should go through the indicies in the reverse order.
static void pushZerosToEnd(int arr[]) { int n = arr.length; int count = 0; // Count of non-zero elements // Traverse the array. If element encountered is non-zero, then // replace the element at index 'count' with this element for (int i = 0; i < n; i++){ if (arr[i] != 0)`enter code here` // arr[count++] = arr[i]; // here count is incremented swapNumbers(arr,count++,i); } for (int j = 0; j < n; j++){ System.out.print(arr[j]+","); } } public static void swapNumbers(int [] arr, int pos1, int pos2){ int temp = arr[pos2]; arr[pos2] = arr[pos1]; arr[pos1] = temp; }
Another variation if you have the array data as a Java-List listOfStuff.add( 0, listOfStuff.remove(listOfStuff.size() - 1) ); Just sharing another option I ran across for this, but I think the answer from #Murat Mustafin is the way to go with a list
public class Test1 { public static void main(String[] args) { int[] x = { 1, 2, 3, 4, 5, 6 }; Test1 test = new Test1(); x = test.shiftArray(x, 2); for (int i = 0; i < x.length; i++) { System.out.print(x[i] + " "); } } public int[] pushFirstElementToLast(int[] x, int position) { int temp = x[0]; for (int i = 0; i < x.length - 1; i++) { x[i] = x[i + 1]; } x[x.length - 1] = temp; return x; } public int[] shiftArray(int[] x, int position) { for (int i = position - 1; i >= 0; i--) { x = pushFirstElementToLast(x, position); } return x; } }
A left rotation operation on an array of size n shifts each of the array's elements unit to the left, check this out!!!!!! public class Solution { private static final Scanner scanner = new Scanner(System.in); public static void main(String[] args) { String[] nd = scanner.nextLine().split(" "); int n = Integer.parseInt(nd[0]); //no. of elements in the array int d = Integer.parseInt(nd[1]); //number of left rotations int[] a = new int[n]; for(int i=0;i<n;i++){ a[i]=scanner.nextInt(); } Solution s= new Solution(); //number of left rotations for(int j=0;j<d;j++){ s.rotate(a,n); } //print the shifted array for(int i:a){System.out.print(i+" ");} } //shift each elements to the left by one public static void rotate(int a[],int n){ int temp=a[0]; for(int i=0;i<n;i++){ if(i<n-1){a[i]=a[i+1];} else{a[i]=temp;} }} }
You can use the Below codes for shifting not rotating: int []arr = {1,2,3,4,5,6,7,8,9,10,11,12}; int n = arr.length; int d = 3; Programm for shifting array of size n by d elements towards left: Input : {1,2,3,4,5,6,7,8,9,10,11,12} Output: {4,5,6,7,8,9,10,11,12,10,11,12} public void shiftLeft(int []arr,int d,int n) { for(int i=0;i<n-d;i++) { arr[i] = arr[i+d]; } } Programm for shifting array of size n by d elements towards right: Input : {1,2,3,4,5,6,7,8,9,10,11,12} Output: {1,2,3,1,2,3,4,5,6,7,8,9} public void shiftRight(int []arr,int d,int n) { for(int i=n-1;i>=d;i--) { arr[i] = arr[i-d]; } }
import java.util.Scanner; public class Shift { public static void main(String[] args) { Scanner input = new Scanner (System.in); int array[] = new int [5]; int array1[] = new int [5]; int i, temp; for (i=0; i<5; i++) { System.out.printf("Enter array[%d]: \n", i); array[i] = input.nextInt(); //Taking input in the array } System.out.println("\nEntered datas are: \n"); for (i=0; i<5; i++) { System.out.printf("array[%d] = %d\n", i, array[i]); //This will show the data you entered (Not the shifting one) } temp = array[4]; //We declared the variable "temp" and put the last number of the array there... System.out.println("\nAfter Shifting: \n"); for(i=3; i>=0; i--) { array1[i+1] = array[i]; //New array is "array1" & Old array is "array". When array[4] then the value of array[3] will be assigned in it and this goes on.. array1[0] = temp; //Finally the value of last array which was assigned in temp goes to the first of the new array } for (i=0; i<5; i++) { System.out.printf("array[%d] = %d\n", i, array1[i]); } input.close(); } }
Write a Java program to create an array of 20 integers, and then implement the process of shifting the array to right for two elements. public class NewClass3 { public static void main (String args[]){ int a [] = {1,2,}; int temp ; for(int i = 0; i<a.length -1; i++){ temp = a[i]; a[i] = a[i+1]; a[i+1] = temp; } for(int p : a) System.out.print(p); } }
How to create random numbers a specific number of times?
How can i create a random number a specific numbers of time? public class Feld { public static void main(String[] args) { double k = (int)(Math.random()*1000001); int n = 1000000; int arr[] = new int[n]; int i = 0; for(i = 0;i<n;i++){ arr[i] = i; } boolean found = false; i=0; while (i < arr.length) { if (arr[i] == k) { found = true; break; } i++; } if (found) { i++; System.out.println(i); } else { System.out.println((arr.length + 1)); } } } My problem is, that if i put k into a loop to create it more than one time i'll get an error at: if (arr[i] == k) !!I just found out that i made a mistake explaining my problem. The array should be filled with values from 0-1.000.000 and i am supposed to print out the position of a random generated number for a specific amount of times.
If you want to have an array full of random numbers, I suggest using the following: int n = 1000000; int arr[] = new int[n]; for(int i = 0; i < n; i++){ arr[i] = (int)(Math.random() * 1000001); } That will work and you don't even need the variable k. Edit: If you want to print at what position you find a specific value (for example x = 543), you can use the following code: int x = 543; int n = 1000000; int arr[] = new int[n]; for(int i = 0; i < n; i++){ arr[i] = (int)(Math.random() * 1000001); if(arr[i] == x) { System.out.println(i); break; } } Edit2 One possible solution to your new problem looks like this: public class Feld { public static void main(String[] args) { int n = 1000000; int arr[] = new int[n]; int i = 0; for(i = 0; i < n; i++){ arr[i] = i; //Filling array with values 0-1000000 } int number = 20; //Print out position of a random generated number a specific amount of times int randomNumber = (int)(Math.random()*1000001); //The random number for(int j = 0; j < number; j++) { //Find number for a specific amount of times for(int k = 0; k < arr.length; k++) { //Find number in array if(arr[k] == randomNumber) { System.out.println(arr[k]); //Print break; //Number found, don't have to search anymore } } } } }
I would write a method that returns an array of random numbers and takes an int argument that defines the length of the array. One possible solution is this: public static int[] createRandomArray(int length) { // create an array of the given length int[] result = new int[length]; // and use a single for loop that puts random int values into every index for (int i = 0; i < result.length; i++) { result[i] = ThreadLocalRandom.current().nextInt(); } // then simply return the result return result; } Try it as follows public static void main(String[] args) { // super primitive time measurement: // take the moment in time before calling the method Instant start = Instant.now(); // then call the method int[] array = createRandomArray(1000000); // and take the moment in time after the method returned Instant end = Instant.now(); // then calculate the duration Duration duration = Duration.between(start, end); // and print the duration in milliseconds System.out.printf("Array creation took %d milliseconds\n", duration.toMillis()); } The result is the following output on my system: Array creation took 10 milliseconds
Creating an Array with the same numbers from an old one but without repetitions
So I created an array with random numbers, i printed and counted the repeated numbers, now I just have to create a new array with the same numbers from the first array but without any repetitions. Can't use ArrayList by the way. What I have is. public static void main(String[] args) { Random generator = new Random(); int aR[]= new int[20]; for(int i=0;i<aR.length;i++){ int number=generator.nextInt(51); aR[i]=number; System.out.print(aR[i]+" "); } System.out.println(); System.out.println(); int countRep=0; for(int i=0;i<aR.length;i++){ for(int j=i+1;j<aR.length-1;j++){ if(aR[i]==aR[j]){ countRep++; System.out.println(aR[i]+" "+aR[j]); break; } } } System.out.println(); System.out.println("Repeated numbers: "+countRep); int newaR[]= new int[aR.length - countRep]; } Can someone help? EDIT: Can't really use HashSet either. Also the new array needs to have the correct size.
Using Java 8 and streams you can do the following: int[] array = new int[1024]; //fill array int[] arrayWithoutDuplicates = Arrays.stream(array) .distinct() .toArray(); This will: Turn your int[] into an IntStream. Filter out all duplicates, so retaining distinct elements. Save it in a new array of type int[].
Try: Set<Integer> insertedNumbers = new HashSet<>(newaR.length); int index = 0; for(int i = 0 ; i < aR.length ; ++i) { if(!insertedNumbers.contains(aR[i])) { newaR[index++] = aR[i]; } insertedNumbers.add(aR[i]); }
One possible approach is to walk through the array, and for each value, compute the index at which it again occurs in the array (which is -1 if the number does not occur again). The number of values which do not occur again is the number of unique values. Then collect all values from the array for which the corresponding index is -1. import java.util.Arrays; import java.util.Random; public class UniqueIntTest { public static void main(String[] args) { int array[] = createRandomArray(20, 0, 51); System.out.println("Array " + Arrays.toString(array)); int result[] = computeUnique(array); System.out.println("Result " + Arrays.toString(result)); } private static int[] createRandomArray(int size, int min, int max) { Random random = new Random(1); int array[] = new int[size]; for (int i = 0; i < size; i++) { array[i] = min + random.nextInt(max - min); } return array; } private static int[] computeUnique(int array[]) { int indices[] = new int[array.length]; int unique = computeIndices(array, indices); int result[] = new int[unique]; int index = 0; for (int i = 0; i < array.length; i++) { if (indices[i] == -1) { result[index] = array[i]; index++; } } return result; } private static int computeIndices(int array[], int indices[]) { int unique = 0; for (int i = 0; i < array.length; i++) { int value = array[i]; int index = indexOf(array, value, i + 1); if (index == -1) { unique++; } indices[i] = index; } return unique; } private static int indexOf(int array[], int value, int offset) { for (int i = offset; i < array.length; i++) { if (array[i] == value) { return i; } } return -1; } }
This sounds like a homework question, and if it is, the technique that you should pick up on is to sort the array first. Once the array is sorted, duplicate entries will be adjacent to each other, so they are trivial to find: int[] numbers = //obtain this however you normally would java.util.Arrays.sort(numbers); //find out how big the array is int sizeWithoutDuplicates = 1; //there will be at least one entry int lastValue = numbers[0]; //a number in the array is unique (or a first duplicate) //if it's not equal to the number before it for(int i = 1; i < numbers.length; i++) { if (numbers[i] != lastValue) { lastValue = i; sizeWithoutDuplicates++; } } //now we know how many results we have, and we can allocate the result array int[] result = new int[sizeWithoutDuplicates]; //fill the result array int positionInResult = 1; //there will be at least one entry result[0] = numbers[0]; lastValue = numbers[0]; for(int i = 1; i < numbers.length; i++) { if (numbers[i] != lastValue) { lastValue = i; result[positionInResult] = i; positionInResult++; } } //result contains the unique numbers Not being able to use a list means that we have to figure out how big the array is going to be in a separate pass — if we could use an ArrayList to collect the results we would have only needed a single loop through the array of numbers. This approach is faster (O(n log n) vs O (n^2)) than a doubly-nested loop through the array to find duplicates. Using a HashSet would be faster still, at O(n).
Given an array with 2 integers that repeat themselves the same no. of times, how do i print the two integers
i'm new to this, Say if you typed 6 6 6 1 4 4 4 in the command line, my code gives the most frequent as only 6 and i need it to print out 6 and 4 and i feel that there should be another loop in my code public class MostFrequent { //this method creates an array that calculates the length of an integer typed and returns //the maximum integer... public static int freq(final int[] n) { int maxKey = 0; //initiates the count to zero int maxCounts = 0; //creates the array... int[] counts = new int[n.length]; for (int i=0; i < n.length; i++) { for (int j=0; j < n[i].length; j++) counts[n[i][j]]++; if (maxCounts < counts[n[i]]) { maxCounts = counts[n[i]]; maxKey = n[i]; } } return maxKey; } //method mainly get the argument from the user public static void main(String[] args) { int len = args.length; if (len == 0) { //System.out.println("Usage: java MostFrequent n1 n2 n3 ..."); return; } int[] n = new int[len + 1]; for (int i=0; i<len; i++) { n[i] = Integer.parseInt(args[i]); } System.out.println("Most frequent is "+freq(n)); } } Thanks...enter code here
Though this may not be a complete solution, it's a suggestion. If you want to return more than one value, your method should return an array, or better yet, an ArrayList (because you don't know how many frequent numbers there will be). In the method, you can add to the list every number that is the most frequest. public static ArrayList<Integer> freq(final int[] n) { ArrayList<Integer> list = new ArrayList<>(); ... if (something) list.add(thatMostFrequentNumber) return list; }
The solutions looks like this: // To use count sort the length of the array need to be at least as // large as the maximum number in the list. int[] counts = new int[MAX_NUM]; for (int i=0; i < n.length; i++) counts[n[i]]++; // If your need more than one value return a collection ArrayList<Integer> mf = new ArrayList<Integer>(); int max = 0; for (int i = 0; i < MAX_NUM; i++) if (counts[i] > max) max = counts[i]; for (int i = 0; i < MAX_NUM; i++) if (counts[i] == max) mf.add(i); return mf;
Well you can just do this easily by using the HashTable class. Part 1. Figure out the frequency of each number. You can do this by either a HashTable or just a simple array if your numbers are whole numbrs and have a decent enough upper limit. Part 2. Find duplicate frequencies. You can just do a simple for loop to figure out which numbers are repeated more than once and then print them accordingly. This wont necessarily give them to you in order though so you can store the information in the first pass and then print it out accordingly. You can use a HashTable<Integer,ArrayList<Integer> for this. Use the key to store frequency and the ArrayList to store the numbers that fall within that frequency. You can maintain a "max" here while inserting into our HashTable if you only want to print out only the things with most frequency.
Here is a different way to handle this. First you sort the list, then loop through and keep track of the largest numbers: class Ideone { public static void main (String[] args) throws java.lang.Exception { int n[] = { 6, 4, 6, 4, 6, 4, 1 }; List<Integer> maxNums = new ArrayList<Integer>(); int max = Integer.MIN_VALUE; Integer lastValue = null; int currentCount = 0; Arrays.sort(n); for( int i : n ){ if( lastValue == null || i != lastValue ){ if( currentCount == max ){ maxNums.add(lastValue); } else if( currentCount > max ){ maxNums.clear(); maxNums.add(lastValue); max = currentCount; } lastValue = i; currentCount = 1; } else { currentCount++; } System.out.println("i=" + i + ", currentCount=" + currentCount); } if( currentCount == max ){ maxNums.add(lastValue); } else if( currentCount >= max ){ maxNums.clear(); maxNums.add(lastValue); } System.out.println(maxNums); } } You can try it at: http://ideone.com/UbmoZ5